/***
*
*  Fileio.prg
*  ਬ 짮⥫᪨ 㭪権  ࠡ⪨  䠩
*  Copyright, Nantucket Corporation, 1990
*
*  ஢  ﬨ: n/w/a/m
*/
/***********
* 䨪 ந  ""  ५ -  1991 .
*     祭 Nantucket Corp.
* ⥫.: (095) 289-43-00, (095) 289-44-77, (095) 289-44-83
* 䠪: (095) 289-34-69
************/

#include "Fileio.ch"

/***
*  FGets( <nHandle>, [<nLines>], [<nLineLength>], [<cDelim>] ) --> cBuffer
*  ⥭   ᪮쪨 ப  ⥪⮢ 䠩
*
*/
FUNCTION FGets(nHandle, nLines, nLineLength, cDelim)
	RETURN FReadLn(nHandle, nLines, nLineLength, cDelim)

/***
*  FPuts( <nHandle>, <cString>, [<nLength>], [<cDelim>] ) --> nBytes
*   ப  ⥪⮢ 䠩
*
*/
FUNCTION FPuts(nHandle, cString, nLength, cDelim)
   RETURN FWriteLn(nHandle, cString, nLength, cDelim)

/***
*  DirEval( <cMask>, <bAction> ) --> aArray
*  믮     䠩, 㤮⢮饣 蠡
*
*  Tim Wong
*/
FUNCTION DirEval( cMask, bAction )
   RETURN AEVAL( DIRECTORY(cMask), bAction )

/***
*  FileTop( <nHandle> ) --> nPos
*  ⠭ 㪠⥫ 樨 筮 䠩  砫 䠩  
*    (.. 0).
*
*/
FUNCTION FileTop(nHandle)
	RETURN FSEEK(nHandle, 0)

/***
*  FileBottom( <nHandle> ) --> nPos
*  ⠭ 㪠⥫ 樨 筮 䠩   䠩  
*   .
*
*/
FUNCTION FileBottom(nHandle)
	RETURN FSEEK(nHandle, 0, FS_END)

/***
*  FilePos( <nHandle> ) --> nPos
*   㪠⥫ ⥪饩 樨 筮 䠩
*
*/
FUNCTION FilePos(nHandle)
	RETURN FSEEK(nHandle, 0, FS_RELATIVE)

/***
*  FileSize( <nHandle> ) --> nBytes
*    筮 䠩
*
*/
FUNCTION FileSize( nHandle )
   LOCAL nCurrent, nLength

   //  
   nCurrent := FilePos(nHandle)

   //  䠩
   nLength := FSEEK(nHandle, 0, FS_END)

   // ⠭ ⥪饩 樨
   FSEEK(nHandle, nCurrent)

   RETURN nLength

/***
*  FReadLn( <nHandle>, [<nLines>], [<nLineLength>], [<cDelim>] ) --> cLines
*  ⥭   ᪮쪨 ப  ⥪⮢ 䠩
*
*  砭:  ப 砥 ࠧ⥫, ⠪ ࠧ, ॠ쭮 :
*        (nLineLength - LEN( cDelim ))
*
*  砭: 頥 祭 砥 ࠧ⥫ ப, ᫨  
*
*  砭: nLines  㬮砭 - 1, nLineLength  㬮砭 - 80,
*              cDelim  㬮砭 - CRLF
*
*  砭: ⮡ 㤮⮢  ᯥ譮 믮 FReadLn(),
*             室 ஢ FERROR()
*
*  砭: FReadLn() 頥 "", ⨣ EOF
*
*/
FUNCTION FReadLn( nHandle, nLines, nLineLength, cDelim )
   LOCAL nCurPos, nFileSize, nChrsToRead, nChrsRead
   LOCAL cBuffer, cLines
   LOCAL nCount
   LOCAL nEOLPos

   IF nLines == NIL
      nLines := 1
   ENDIF

   IF nLineLength == NIL
      nLineLength := 80
   ENDIF

   IF cDelim == NIL
      cDelim := CHR(13) + CHR(10)
   ENDIF

   nCurPos   := FilePos( nHandle )
   nFileSize := FileSize( nHandle )

   //   ⪨   ࠭楩 䠩
   nChrsToRead := MIN( nLineLength, nFileSize - nCurPos )

   cLines  := ''
   nCount  := 1
   DO WHILE (nCount <= nLines) .AND. ( nChrsToRead != 0 )
      cBuffer   := SPACE( nChrsToRead )
      nChrsRead := FREAD( nHandle, @cBuffer, nChrsToRead )

      // ஢ઠ 訡
      IF ! (nChrsRead == nChrsToRead)
         // 訡!
         //  浪 ࠭ ᮢ⨬  㣨 㭪ﬨ
         //  ஢, 㤨 짮⥫ ஢ FERROR()
         //   ⮣ 䠪
         //
         nChrsToRead := 0
      ENDIF

      nEOLPos := AT( cDelim, cBuffer )

      //    ⥪饩 樨  䠩
      IF nEOLPos == 0
         cLines  += LEFT( cBuffer, nChrsRead )
         nCurPos += nChrsRead
      ELSE
         cLines  += LEFT( cBuffer, ( nEOLPos + LEN( cDelim ) ) - 1 )
         nCurPos += ( nEOLPos + LEN( cDelim ) ) - 1
         FSEEK( nHandle, nCurPos, FS_SET )
      ENDIF

      // ஢ઠ ⮣,   뫮 ⪨   ࠭楩 䠩
      IF (nFileSize - nCurPos) < nLineLength
         nChrsToRead := (nFileSize - nCurPos)
      ENDIF

      nCount++
   ENDDO

   RETURN cLines

/***
*  FileEval( <nHandle>, [<nLineLength>], [<cDelim>], ;
*            <bBlock>,
*            [<bForCondition>],
*            [<bWhileCondition>],
*            [<nNextLines>],
*            [<nLine>],
*            [<lRest>] )   --> NIL
*  믮     ப 筮 䠩, ᯮ DBEVAL()
*  ᫨,  ⮬, 䠩 ,  १  뢠
*   ६ 䠩,   砭 - ९뢠  室.
*
*  砭:  <bBlock>, <bForCondition>  <bWhileCondition> ⭮
*               ப 䠩
*
*  砭:  祭  㬮砭  nLineLength  cDelim  ,  
*               㭪樨 FReadLn()
*
*  砭:  祭  㬮砭  ⠢ ࠬ஢  ,   
*              DBEVAL().
*
*  砭:     EOF (nLine > ᫥ ப 䠩  ..)
*                樨 訡. ⥫ 
*              ⠭  EOF.
*
*  砭:  ஢ઠ FERROR() -  㤮⮢७  ᯥ譮
*
*  :  Craig Ogg
*
*/
PROCEDURE FileEval( nHandle, nLineLength, cDelim, bBlock, bFor, bWhile, ;
                    nNextLines, nLine, lRest )
   LOCAL cLine
   LOCAL lEOF := .F.
   LOCAL nPrevPos

   IF bWhile == NIL
      bWhile := {|| .T.}
   ENDIF

   IF bFor == NIL
      bFor := {|| .T.}
   ENDIF

   // lRest == .T. 砥 砫  ⥪饩 ப,  -  砫 䠩
   //
   IF ! ( ( VALTYPE(lRest) == 'L' ) .AND. ( lRest == .T. ) )
      FileTop( nHandle )
   ENDIF

   BEGIN SEQUENCE
      IF nLine != NIL
         //  ⮫쪮   ப, 稭  nLine
         nNextLines := 1

         FileTop( nHandle )

         IF nLine > 1
            cLine := FReadLn( nHandle, 1, nLineLength, cDelim )
            IF FERROR() != 0
               BREAK
            ENDIF

            lEOF := ( cLine == "" )
            nLine--
         ENDIF

         // ।   ப (nLine 㤥 ࠢ 1  ⮩ ப)
         DO WHILE ( ! lEOF  ) .AND. (nLine > 1)
            cLine := FReadLn( nHandle, 1, nLineLength, cDelim )
            IF FERROR() != 0
               BREAK
            ENDIF

            lEOF := ( cLine == "" )
            nLine--
         ENDDO
      ENDIF

      // ࠭ 砫쭮 樨
      nPrevPos := FilePos( nHandle)

      // ᫨    ,   ப  ࠢ  
      // ࠡ⪨
      //
      IF ( ! lEOF ) .AND. (nNextLines == NIL .OR. nNextLines > 0)
         cLine := FReadLn( nHandle, 1, nLineLength, cDelim )
         IF FERROR() != 0
            BREAK
         ENDIF

         lEOF := ( cLine == "" )
      ENDIF

      DO WHILE ( ! lEOF ) .AND. EVAL( bWhile, cLine ) ;
                        .AND. (nNextLines == NIL .OR. nNextLines > 0)

         IF EVAL( bFor, cLine )
            EVAL( bBlock, cLine )
         ENDIF

         // ࠭ 樨 砫 ப
         nPrevPos := FilePos( nHandle )

         // ⥭ ᫥饩 ப
         cLine    := FReadLn( nHandle, 1, nLineLength, cDelim )
         IF FERROR() != 0
            BREAK
         ENDIF

         lEOF     := ( cLine == "" )

         IF nNextLines != NIL
            nNextLines--
         ENDIF
      ENDDO

      // ᫨  ᫮  砭    WHILE,   
      //   ࠡ⪨ ப,  室 -  砫 ப,  ன
      // 稫 ࠡ⪠.
      //
      IF ( ! EVAL( bWhile, cLine ) ) .OR. ;
         ( (nNextLines != NIL) .AND. (nNextLines == 0) )

         FSEEK( nHandle, nPrevPos, FS_SET )
      ENDIF
   END SEQUENCE

   RETURN


/***
*  FEof( <nHandle> ) --> lBoundary
*  ।,    ⥪   䠩  殬
*  (᫥ )
*
*/
FUNCTION FEof( nHandle )
   RETURN (IF(FileSize(nHandle) == FilePos(nHandle), .T., .F. ))


/***
*  FWriteLn( <nHandle>, <cString>, [<nLength>], [<cDelim>] ) --> nBytes
*   ப  ⥪饩 樨 䠩
*
*  砭:  ஢ન 䠩 訡 ᯮ FERROR()
*
*  砭: nLength =  ப + ࠧ⥫, cDelim  㬮砭 =
*             CHR(13) + CHR(10)
*
*  砭: 頥 祭 砥  ࠧ⥫
*
*/
FUNCTION FWriteLn( nHandle, cString, nLength, cDelim )

   IF cDelim == NIL
      cString += CHR(13) + CHR(10)
   ELSE
      cString += cDelim
   ENDIF

   RETURN FWRITE( nHandle, cString, nLength )